'FFSubmenu=Effekte
'FFName=Buntstiftzeichnung

'(c) Harald Maeckler, Dsseldorf 2010

' ********************************************************************
' Buntstift.vbs (Script fr FixFoto)
' Funktion: verwandelt das geladene Bild in eine Bleistiftzeichnung

' Version 1.00 vom 22.02.2010	- Betaversion
'  
'** Start Kurzbeschreibung *******************************************
' Buntstiftzeichnung / Version 1.00
' ====================
' Das Skript verwandelt das geladene Bild in eine Buntstiftzeichnung. Man kann whlen
' ob der Hintergrund hell oder dunkel sein soll.

' Mit Auslsung des Befehls 'farbig' wird zuerst ein Dialog zur Kontrasteinstellung und
' dann zur Einstellung der Farbssttigung angeboten.
' Whlt man 'schwarz/wei' wird nur der Dialog zur Kontrasteinstellung aufgerufen.
'
' Wird ein Dialog nicht mit 'Ausfhren' sondern mit 'Schlieen beendet, wird das Skript
' abgebrochen und das Bild bleibt unverndert.
'
' Deinstallation des Skripts 'Ordner lschen'
' =========================
' Wird die Entfernung des Skripts gewnscht, kann mit der Tastenkombination Alt + D eine 
' Lschroutine aufgerufen werden. Nach einer Sicherheitsabfrage wird berprft, ob das 
' zugehrige zip-Archiv im Skriptordner abgelegt ist. Wenn ja, wird vor dem Lschen ange-
' boten, davon eine Sicherheitskopie an einem beliebigen Speicherort abzulegen. Danach 
' wird die Skriptdatei gelscht und abschlieend die FixFotoScript.ini bereinigt.
' Nach manueller Durchfhrung einer 'Automatischen Skriptkonfiguration' ist das Skript aus 
' der FixFoto-Umgebung entfernt.
'
'
' Benutzung des Skripts auf eigene Gefahr!
'
' Copyright Harald Maeckler
'** Ende Kurzbeschreibung ********************************************

Option Explicit

const SkriptName = "Buntstift.vbs"							'Skriptname

Dim Kurzbeschreibung, KBvorhanden, LaengeMax, Abbruch		'Kurzbeschreibung
const ForReading = 1, ForWriting = 2

Dim SkriptKill : SkriptKill = false							'Skript lschen
Dim Antwort

Dim objFS													'Objekte
Set objFS = CreateObject("Scripting.FileSystemObject")

Dim flagMonochrom

'---------------------------------------------------------------------
call Main
'---------------------------------------------------------------------
Sub Main	'### Hauptprogramm

on error resume next											'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetImageCount
 	if Err.Number = 500 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if FF_GetImageWidth = 0 then
	msgbox "Es ist kein Bild geladen!",vbexclamation,"Abbruch"	'Kontrolle ob Bild geladen
	exit sub
end if

'** Start Dialog Buntstiftzeichnung **
FF_AddDialog "Buntstiftzeichnung",105,75
FF_AddControl "Buntstiftzeichnung","Auswahl","GROUP",5,6,94,42
FF_AddControl "Buntstiftzeichnung","flagNotNegate","BOOL",24,18,8,8
FF_AddControl "Buntstiftzeichnung","dunkler Hintergrund","STATIC",36,17,50,10
FF_AddControl "Buntstiftzeichnung","farbig","BUTTON",10,30,38,11
FF_AddControl "Buntstiftzeichnung","schwarz/wei","BUTTON",55,30,38,11
FF_AddControl "Buntstiftzeichnung","?","BUTTON",10,54,11,12
FF_AddControl "Buntstiftzeichnung","Abbrechen","BUTTON",60,55,33,11
FF_AddControl "Buntstiftzeichnung","&d","BUTTON",0,0,1,1
'** End Dialog Buntstiftzeichnung **

FF_ActivateControl "Buntstiftzeichnung","&d"

do
	Select Case FF_ShowDialog ("Buntstiftzeichnung")
	Case "&d"
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "farbig"
		flagMonochrom = false
		call Zeichnung
		exit do
	Case "schwarz/wei"
		flagMonochrom = true
		call Zeichnung
		exit do
	Case "?"
		Abbruch = false
		if not KBvorhanden then	call KurzbeschreibungLesen
		if KBvorhanden then
			call KurzbeschreibungAnzeigen
		else
			msgbox "Keine Kurzbeschreibung gefunden!",vbExclamation,"Meldung"
		end if
	Case "CANCEL","Abbrechen"
		exit do
	Case Else
	End Select
loop

FF_CloseDialog ("Buntstiftzeichnung")
if SkriptKill then	'ggf. Skript 'Ordner lschen' komplett entfernen
	call KillSkript
end if

End sub
'------------------------------------------------------------------------
Sub KurzbeschreibungAnzeigen

Dim Taste
Dim Breite	: Breite = LaengeMax * 2.6 + 15
const Hoehe = 180

const ES_READONLY = 2048
const WS_VSCROLL = 2097152

FF_AddDialog "Kurzbeschreibung",Breite,Hoehe
FF_AddControl "Kurzbeschreibung","Beschreibung","EDIT",0,0,Breite,Hoehe-20
FF_SetControlStyle "Kurzbeschreibung","Beschreibung", ES_READONLY + WS_VSCROLL
FF_AddControl "Kurzbeschreibung","OK","BUTTON",Breite/2-15,Hoehe-15,30,10

FF_SetControl "Kurzbeschreibung","Beschreibung",Kurzbeschreibung

do
	Taste = FF_ShowDialog("Kurzbeschreibung")
	if Taste = "CANCEL" or Taste = "OK" then exit do
loop
call FF_CloseDialog("Kurzbeschreibung")

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungLesen
on error resume next
Const ForReading = 1
Dim Skript, Anfang, Ende, Zeile

Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)

if err.number = 53 then
	msgbox "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   "Die Kurzbeschreibung kann daher nicht angezeigt werden.",vbExclamation,"Meldung"
	Abbruch = True
	exit sub
end if

Do While Skript.AtEndOfStream <> True
	Zeile = Skript.ReadLine
	
	if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
	if Ende then exit do
	
	if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
	if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
	
	if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	
Loop
	
if Anfang and Ende then KBvorhanden = true
Skript.Close

End Sub
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad
const RegSchluessel = "\FF_Buntstift\"

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien und Ordner lschen
'TempFile = FF_GetScriptPath & "\Beipack.txt"		'Dateibeispiel
'if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

'TempFile = FF_GetScriptPath & "\BeipackSammlung"	'Ordnerbeispiel
'if objFS. FolderExists (TempFile) then objFS. DeleteFolder TempFile,true

'### ggf. Registry-Daten lschen
'TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script" & RegSchluessel
'WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Das Skript" & Skriptname & vbNewLine & "wurde mit allen Komponenten gelscht!",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
Sub Zeichnung
'Bleistiftzeichnung erstellen
Dim flagNotNegate

flagNotNegate = FF_GetControl("Buntstiftzeichnung","flagNotNegate")

	call FF_Sobel()							'Kantenmaske erstellen - so
	
	if flagNotNegate = 0 then
		call FF_Negate()					'Negativieren
	end if
	
	if flagMonochrom then
		call FF_Saturation(0)				'Sttigung auf 0 (-4.0 bis +4.0)	- <> 0 ergibt farbiges Bild
	end if

	if flagNotNegate = 1 then
		FF_SetParam "0,100"
	else
		FF_SetParam "100,255"
	end if

	Antwort = FF_MultiDialog ("MultiContrast",0)	'Kontrasteinstellung	- einstellbarer Dialog
	if Antwort < 0 then 
		exit sub
	end if
	
	if not flagMonochrom then
		FF_SetParam "200"
		Antwort = FF_Multidialog("MultiSatu",0)		'Farbsttigung			- einstellbarer Dialog
		if Antwort < 0 then 
			exit sub
		end if		
	end if
	
	call FF_Reload()						'Bild zurck laden

End Sub
'------------------------------------------------------------------------
